	include p16f689.inc
	include macros.inc
	
	__CONFIG _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTOSCIO

v_main  code 0x0000
	goto main

v_inter code 0x0004
	movf PORTA, W
	bcf INTCON, RABIF
	goto main

	udata_shr
d0	res 1
d1	res 1
d2	res 1
	
	; Ports:
	; RA0: Switch (active high)
	; RC4-7: Leds (active high)
	; RC3: VCC

#define LED1	PORTC, 4
#define LED2	PORTC, 5
#define LED3	PORTC, 6
#define LED4	PORTC, 7

	extern rnd_get

	code

set_random_led
	call rnd_get
	
	banksel PORTA
	
	addlw 0
	btfsc STATUS, Z
	bsf LED1
	
	addlw -1
	btfsc STATUS, Z
	bsf LED2
	
	addlw -1
	btfsc STATUS, Z
	bsf LED3
	
	addlw -1
	btfsc STATUS, Z
	bsf LED4
	
	return

	; Delay specified number of seconds
delay_s
	movwf	d0

delay_s_0
	movlw	0x65
	movwf	d1
	movlw	0x07
	movwf	d2
delay_s_1
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	delay_s_1
	
	decfsz	d0, f
	goto	delay_s_0
	
	return


main
	banksel OSCCON
	clrf OSCCON ; 32kHz

	banksel PORTA
	clrf PORTB
	clrf PORTC
	
	banksel ANSEL
	clrf ANSEL ; Digital IO
	clrf ANSELH
	
	banksel IOCA
	movlw 0x01
	movwf IOCA
	
	banksel TRISC
	movlw 0x08
	movwf TRISC
	movlw 0x01
	movwf TRISA
	clrf TRISB

	banksel PORTA
	movf PORTA, W	; Reload IOC latch
	
	banksel INTCON
	movlw 0x08	; Enable interrupt on change
	movwf INTCON

	banksel PORTA
	btfsc PORTA, 0
	goto poweron
	
	sleep
	goto main

poweron
	call set_random_led
	
	bsf INTCON, GIE
	movlw 15
	call delay_s
	bcf INTCON, GIE
	
	banksel PORTA
	clrf PORTC
	
	movf PORTA, W
	bcf INTCON, RABIF
	
	sleep
	
	goto main

    end
